/**********************************************************************************
*
*	AdThemes - Covers CS ads with 'sheets' as specified in adthemes_???.cfg file
*	Written by Vet(3TT3V) - www.rip2001.com - partymix@gmail.com
*
*	Commands: (Takes affect when map change)
*		amx_adthemes_enable - Toggles AdThemes On|Off
*		amx_adthemes_file <filename> - Changes the AdThemes config file.
*
***********************************************************************************/

#define PLUGIN "AdThemes"
#define VERSION "1.8"
#define AUTHOR "Vet(3TT3V)"
#define SVARIABLE "AdThemes"
#define SVALUE "v1.8 by Vet(3TT3V)"

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

#define MAX_MODELS 16
#define MODEL_DIR "models/adthemes"
#define DEFAULT_CFG "adthemes_none.cfg"
#define ENT_CLASSNAME "info_target"

// From Ven's fakemeta_util include
#define fm_create_entity(%1) engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, %1))
#define fm_DispatchSpawn(%1) dllfunc(DLLFunc_Spawn, %1)
#define fm_entity_set_model(%1,%2) engfunc(EngFunc_SetModel, %1, %2)

new g_adsheet[MAX_MODELS][64]
new g_cfg_dir[64]
new g_cfg_file[96]
new g_theme_cfg[32]
new g_cfg_lines
new g_line_text[128]
new g_line_num
new g_line_len
new g_datafound
new g_model_cnt
new g_enabled
new g_theme

public plugin_precache()
{
	g_enabled = register_cvar("amx_adthemes", "1")
	g_theme = register_cvar("amx_adthemescfg", DEFAULT_CFG)
	if(!get_pcvar_num(g_enabled))
		return PLUGIN_CONTINUE
	new mapname[32]
	get_configsdir(g_cfg_dir, 79)
	trim(g_cfg_dir)
	get_pcvar_string(g_theme, g_theme_cfg, 31)
	format(g_cfg_file, 95, "%s/%s", g_cfg_dir, g_theme_cfg)
	if(!file_exists(g_cfg_file)) {
		log_message("[AMXX] AdThemes - Config file not found.")
		return PLUGIN_CONTINUE
	}

	g_datafound = 0
	get_mapname(mapname, 31)
	format(mapname, 31, "[%s]", mapname)
	g_cfg_lines = file_size(g_cfg_file, 1)

	for(g_line_num = 0; g_line_num <= g_cfg_lines; g_line_num++) {
		read_file(g_cfg_file, g_line_num, g_line_text, 127, g_line_len)
		if(equali(mapname, g_line_text)) {
			g_datafound = 1
			break
		}
	}
	if(!g_datafound) {
		log_message("[AMXX] AdThemes - No map data found.")
		return PLUGIN_CONTINUE
	}

	new modelname[64]
	g_model_cnt = 0
	g_line_num++
	read_file(g_cfg_file, g_line_num, g_line_text, 127, g_line_len)
	while (!equali(g_line_text, "}") && g_model_cnt < MAX_MODELS && g_line_num <= g_cfg_lines) {
		strtok(g_line_text, modelname, 63, g_line_text, 63, '/', 0)
		format(g_adsheet[g_model_cnt], 63, "%s/%s", MODEL_DIR, modelname)
		if (file_exists(g_adsheet[g_model_cnt])) {
			precache_model(g_adsheet[g_model_cnt])
		} else {
			g_datafound = 0
			log_message("[AMXX] AdThemes - Disabling plugin. (Model not found)")
			break
		}

		g_model_cnt++
		g_line_num++
		read_file(g_cfg_file, g_line_num, g_line_text, 127, g_line_len)
	}
	return PLUGIN_CONTINUE
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_concmd("amx_adthemes_file", "change_cfg_file", ADMIN_CFG, "<filename> - Change AdThemes config file.")
	register_concmd("amx_adthemes_enable", "toggle_adthemes", ADMIN_CFG, "amx_adthemes_enable - Toggle AdThemes On/Off.")
	register_cvar(SVARIABLE, SVALUE, FCVAR_SERVER|FCVAR_SPONLY)

	if(!g_datafound || !get_pcvar_num(g_enabled))
		return PLUGIN_CONTINUE

	log_message("[AMXX] AdThemes - Map data found. Inserting sheet(s)")
	new origin[32]
	new style[4]
	new style_num
	new angles[16]
	new ent

	g_line_num++
	read_file(g_cfg_file, g_line_num, g_line_text, 127, g_line_len)
	while (!equali(g_line_text, "}") && g_line_num <= g_cfg_lines) {
		strtok(g_line_text, origin, 31, g_line_text, 95, '/', 0)
		strtok(g_line_text, style, 3, g_line_text, 91, '/', 0)
		strtok(g_line_text, angles, 15, g_line_text, 75, '/', 0)

		style_num = str_to_num(style)
		if(style_num < 1 || style_num > g_model_cnt) {
			log_message("[AMXX] AdThemes - ModleID out of range.")
		} else {
			--style_num

			ent = fm_create_entity(ENT_CLASSNAME)
			if(!ent) {
				log_message("[AMXX] AdThemes - Entity could not be created.")
				return PLUGIN_HANDLED
			}
			fm_set_kvd(ent, "origin", origin)
			fm_set_kvd(ent, "angles", angles)
			fm_entity_set_model(ent, g_adsheet[style_num])

			fm_DispatchSpawn(ent)
		}
		g_line_num++
		read_file(g_cfg_file, g_line_num, g_line_text, 127, g_line_len)
	}

	return PLUGIN_CONTINUE
}

public change_cfg_file(id,lvl,cid)
{
	if (!cmd_access(id, lvl, cid, 2))
		return PLUGIN_HANDLED
		
	new tmp_cfg[96]
	new uname[32]
	get_user_name(id, uname, 31)
	read_argv(1, g_theme_cfg, 31)
	format(tmp_cfg, 95, "%s/%s", g_cfg_dir, g_theme_cfg)
	if(!file_exists(tmp_cfg)) {
		console_print(id, "AdTheme config file not found.")
		return PLUGIN_HANDLED
	}

	set_cvar_string("amx_adthemescfg", g_theme_cfg)
	console_print(id, "AdThemes config file changed to %s", g_theme_cfg)
	log_message("[AMXX] AdThemes - Admin %s changed AdThemes config file to %s", uname, g_theme_cfg)

	return PLUGIN_HANDLED
}

public toggle_adthemes(id,lvl,cid)
{
	if (!cmd_access(id, lvl, cid, 1))
		return PLUGIN_HANDLED

	new uname[32]
	get_user_name(id, uname, 31)
	if(!get_pcvar_num(g_enabled)) {
		set_cvar_string("amx_adthemes", "1")
		console_print(id, "AdThemes are now Enabled")
		log_message("[AMXX] AdThemes - Admin %s set AdThemes to 'Enabled'", uname)
	} else {
		set_cvar_string("amx_adthemes", "0")
		console_print(id, "AdThemes are now Disabled")
		log_message("[AMXX] AdThemes - Admin %s set AdThemes to 'Disabled'", uname)
	}

	return PLUGIN_HANDLED
}

// From Ven's fakemeta_util include
// based on Basic-Master's set_keyvalue, upgraded version optionally accepts a classname
stock fm_set_kvd(entity, const key[], const value[], const classname[] = "") {
	if (classname[0])
		set_kvd(0, KV_ClassName, classname)
	else {
		new class[32]
		pev(entity, pev_classname, class, 31)
		set_kvd(0, KV_ClassName, class)
	}

	set_kvd(0, KV_KeyName, key)
	set_kvd(0, KV_Value, value)
	set_kvd(0, KV_fHandled, 0)

	return dllfunc(DLLFunc_KeyValue, entity, 0)
}